import { EffectCallback, DependencyList } from 'react';
import { DataSet } from 'choerodon-ui/pro';

declare const useMount: (fn: () => void) => void;

declare const useUnmount: (fn: () => void) => void;

declare const useEffectOnce: (mountFn?: (() => void) | undefined, unMountFn?: (() => void) | undefined) => void;

declare const useUpdate: () => () => void;

declare const useUpdateEffect: (effect: EffectCallback, deps?: DependencyList | undefined) => void;

declare const useArray: <T>(initialValue?: T[]) => any[];

declare const useCode: (code: string, queryCode: (arg0: string) => any, refresh?: boolean | undefined) => never[];

declare type DataSetFactory = () => DataSet;
declare const useDataSet: (dataSetFactory: DataSetFactory, cacheKey?: string | undefined) => DataSet;

declare const useDataSetIsSelected: (dataSet: DataSet) => boolean;

declare const useDataSetEvents: (dataSet: DataSet, eventNames: string | string[], handler: CallableFunction, options?: AddEventListenerOptions | undefined) => void;

declare const useTodayPoetry: (intervalTime?: number | undefined) => {
    content: string;
    tags: string[];
    origin: any;
    loading: boolean;
    allData: any;
    update: () => void;
};

export { useArray, useCode, useDataSet, useDataSetEvents, useDataSetIsSelected, useEffectOnce, useMount, useTodayPoetry, useUnmount, useUpdate, useUpdateEffect };
